Index: branches/HTM-14.0-dev0/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- branches/HTM-14.0-dev0/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1186)
+++ branches/HTM-14.0-dev0/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1187)
@@ -541,5 +541,5 @@
         TComDataCU* pcTextureCU = pcTexture->getCU( rpcBestCU->getAddr() ); //Corresponding texture LCU
         UInt uiCUIdx            = rpcBestCU->getZorderIdxInCU();
-        assert(pcTextureCU->getDepth(uiCUIdx) >= uiDepth); //Depth cannot be more partitionned than the texture.
+        assert(pcTextureCU->getDepth(uiCUIdx) >= uiDepth); //Depth cannot be more partitioned than the texture.
         if (pcTextureCU->getDepth(uiCUIdx) > uiDepth || pcTextureCU->getPartitionSize(uiCUIdx) == SIZE_NxN) //Texture was split.
         {
@@ -556,7 +556,11 @@
           {
             if(pcTextureCU->getPartitionSize(uiCUIdx)==SIZE_2NxN || pcTextureCU->getPartitionSize(uiCUIdx)==SIZE_2NxnU|| pcTextureCU->getPartitionSize(uiCUIdx)==SIZE_2NxnD)
+            {
               bTry2NxN  = true;
+            }
             else
+            {
               bTryNx2N  = true;
+            }
           }
         }
@@ -592,10 +596,13 @@
 #endif 
 #if H_3D_NBDV_REF
-          if( rpcTempCU->getSlice()->getDepthRefinementFlag() )
-            rpcTempCU->getDisMvpCandNBDV(&DvInfo, true);
-          else
+            if( rpcTempCU->getSlice()->getDepthRefinementFlag() )
+            {
+              rpcTempCU->getDisMvpCandNBDV(&DvInfo, true);
+            }
+            else
 #endif 
-            rpcTempCU->getDisMvpCandNBDV(&DvInfo);
-
+            {
+              rpcTempCU->getDisMvpCandNBDV(&DvInfo);
+            }
 #if H_3D_IV_MERGE
           }
@@ -624,36 +631,36 @@
           Bool bICFlag = uiICId ? true : false;
 #endif
-        // 2Nx2N
-        if(m_pcEncCfg->getUseEarlySkipDetection())
-        {
+          // 2Nx2N
+          if(m_pcEncCfg->getUseEarlySkipDetection())
+          {
+#if H_3D_IC
+            rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
+#endif
+#if  H_3D_FAST_TEXTURE_ENCODING
+            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N, bFMD );  rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode  );//by Competition for inter_2Nx2N
+#else
+            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
+            rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );//by Competition for inter_2Nx2N
+#endif
+#if H_3D_VSP
+            rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
+#endif
+          }
+          // SKIP
 #if H_3D_IC
           rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
 #endif
+          xCheckRDCostMerge2Nx2N( rpcBestCU, rpcTempCU, &earlyDetectionSkipMode );//by Merge for inter_2Nx2N
 #if  H_3D_FAST_TEXTURE_ENCODING
-          xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N, bFMD );  rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode  );//by Competition for inter_2Nx2N
-#else
-          xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
-          rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );//by Competition for inter_2Nx2N
-#endif
+          bFMD = bIVFMerge && rpcBestCU->isSkipped(0);
+#endif
+          rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
 #if H_3D_VSP
           rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
-        }
-        // SKIP
-#if H_3D_IC
-        rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
-#endif
-        xCheckRDCostMerge2Nx2N( rpcBestCU, rpcTempCU, &earlyDetectionSkipMode );//by Merge for inter_2Nx2N
-#if  H_3D_FAST_TEXTURE_ENCODING
-        bFMD = bIVFMerge && rpcBestCU->isSkipped(0);
-#endif
-        rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if H_3D_VSP
-        rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
-#endif
-
-        if(!m_pcEncCfg->getUseEarlySkipDetection())
-        {
-          // 2Nx2N, NxN
+
+          if(!m_pcEncCfg->getUseEarlySkipDetection())
+          {
+            // 2Nx2N, NxN
 #if H_3D_IC
             rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
@@ -662,27 +669,26 @@
             xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N, bFMD );  rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
 #else
-          xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
-          rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
+            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
+            rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
 #endif
 #if H_3D_VSP
             rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
-          
+
 #if H_3D_DBBP
-          if( rpcTempCU->getSlice()->getDepthBasedBlkPartFlag() && rpcTempCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
-          {
-            xCheckRDCostInterDBBP( rpcBestCU, rpcTempCU, false );
-            rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode  );
+            if( rpcTempCU->getSlice()->getDepthBasedBlkPartFlag() && rpcTempCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
+            {
+              xCheckRDCostInterDBBP( rpcBestCU, rpcTempCU, false );
+              rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode  );
 #if H_3D_VSP
-            rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
-#endif
-          }
-#endif
-          
+              rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
+#endif
+            }
+#endif
             if(m_pcEncCfg->getUseCbfFastMode())
             {
               doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
             }
-        }
+          }
 #if H_3D_IC
         }
@@ -1771,5 +1777,5 @@
   Bool bICFlag = rpcTempCU->getICFlag( 0 );
 #endif
-#if H_3D_VSO // M1  //nececcary here?
+#if H_3D_VSO // M1  //necessary here?
   if( m_pcRdCost->getUseRenModel() )
   {
@@ -1896,14 +1902,14 @@
     {      
 #if H_3D_IC
-        if( rpcTempCU->getSlice()->getApplyIC() && rpcTempCU->getSlice()->getIcSkipParseFlag() )
+      if( rpcTempCU->getSlice()->getApplyIC() && rpcTempCU->getSlice()->getIcSkipParseFlag() )
+      {
+        if( bICFlag && uiMergeCand == 0 ) 
         {
-          if( bICFlag && uiMergeCand == 0 ) 
-          {
-            continue;
-          }
+          continue;
         }
-#endif
-        if(!(uiNoResidual==1 && mergeCandBuffer[uiMergeCand]==1))
-        {
+      }
+#endif
+      if(!(uiNoResidual==1 && mergeCandBuffer[uiMergeCand]==1))
+      {
         if( !(bestIsSkip && uiNoResidual == 0) )
         {
@@ -1944,67 +1950,67 @@
 #if H_3D_VSP
           {
-          if ( vspFlag[uiMergeCand] )
-          {
-            UInt partAddr;
-            Int vspSize;
-            Int width, height;
-            rpcTempCU->getPartIndexAndSize( 0, partAddr, width, height );
-            if( uhInterDirNeighbours[ uiMergeCand ] & 0x01 )
+            if ( vspFlag[uiMergeCand] )
             {
-              rpcTempCU->setMvFieldPUForVSP( rpcTempCU, partAddr, width, height, REF_PIC_LIST_0, cMvFieldNeighbours[ 2*uiMergeCand + 0 ].getRefIdx(), vspSize );
-              rpcTempCU->setVSPFlag( partAddr, vspSize );
+              UInt partAddr;
+              Int vspSize;
+              Int width, height;
+              rpcTempCU->getPartIndexAndSize( 0, partAddr, width, height );
+              if( uhInterDirNeighbours[ uiMergeCand ] & 0x01 )
+              {
+                rpcTempCU->setMvFieldPUForVSP( rpcTempCU, partAddr, width, height, REF_PIC_LIST_0, cMvFieldNeighbours[ 2*uiMergeCand + 0 ].getRefIdx(), vspSize );
+                rpcTempCU->setVSPFlag( partAddr, vspSize );
+              }
+              else
+              {
+                rpcTempCU->getCUMvField( REF_PIC_LIST_0 )->setAllMvField( cMvFieldNeighbours[0 + 2*uiMergeCand], SIZE_2Nx2N, 0, 0 ); // interprets depth relative to rpcTempCU level
+              }
+              if( uhInterDirNeighbours[ uiMergeCand ] & 0x02 )
+              {
+                rpcTempCU->setMvFieldPUForVSP( rpcTempCU, partAddr, width, height, REF_PIC_LIST_1 , cMvFieldNeighbours[ 2*uiMergeCand + 1 ].getRefIdx(), vspSize );
+                rpcTempCU->setVSPFlag( partAddr, vspSize );
+              }
+              else
+              {
+                rpcTempCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMvFieldNeighbours[1 + 2*uiMergeCand], SIZE_2Nx2N, 0, 0 ); // interprets depth relative to rpcTempCU level
+              }
+              rpcTempCU->setInterDirSubParts( uhInterDirNeighbours[uiMergeCand], 0, 0, uhDepth ); // interprets depth relative to LCU level
             }
             else
             {
+#endif
+              rpcTempCU->setInterDirSubParts( uhInterDirNeighbours[uiMergeCand], 0, 0, uhDepth ); // interprets depth relative to LCU level
               rpcTempCU->getCUMvField( REF_PIC_LIST_0 )->setAllMvField( cMvFieldNeighbours[0 + 2*uiMergeCand], SIZE_2Nx2N, 0, 0 ); // interprets depth relative to rpcTempCU level
+              rpcTempCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMvFieldNeighbours[1 + 2*uiMergeCand], SIZE_2Nx2N, 0, 0 ); // interprets depth relative to rpcTempCU level
+#if H_3D_VSP
             }
-            if( uhInterDirNeighbours[ uiMergeCand ] & 0x02 )
-            {
-              rpcTempCU->setMvFieldPUForVSP( rpcTempCU, partAddr, width, height, REF_PIC_LIST_1 , cMvFieldNeighbours[ 2*uiMergeCand + 1 ].getRefIdx(), vspSize );
-              rpcTempCU->setVSPFlag( partAddr, vspSize );
-            }
-            else
-            {
-              rpcTempCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMvFieldNeighbours[1 + 2*uiMergeCand], SIZE_2Nx2N, 0, 0 ); // interprets depth relative to rpcTempCU level
-            }
-            rpcTempCU->setInterDirSubParts( uhInterDirNeighbours[uiMergeCand], 0, 0, uhDepth ); // interprets depth relative to LCU level
           }
-          else
+#endif
+          // do MC
+          m_pcPredSearch->motionCompensation ( rpcTempCU, m_ppcPredYuvTemp[uhDepth] );
+          // estimate residual and encode everything
+#if H_3D_VSO //M2
+          if( m_pcRdCost->getUseRenModel() )
+          { //Reset
+            UInt  uiWidth     = m_ppcOrigYuv[uhDepth]->getWidth    ();
+            UInt  uiHeight    = m_ppcOrigYuv[uhDepth]->getHeight   ();
+            Pel*  piSrc       = m_ppcOrigYuv[uhDepth]->getLumaAddr ();
+            UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride   ();
+            m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
+          }
+#endif
+          m_pcPredSearch->encodeResAndCalcRdInterCU( rpcTempCU,
+            m_ppcOrigYuv    [uhDepth],
+            m_ppcPredYuvTemp[uhDepth],
+            m_ppcResiYuvTemp[uhDepth],
+            m_ppcResiYuvBest[uhDepth],
+            m_ppcRecoYuvTemp[uhDepth],
+            (uiNoResidual? true:false));
+
+
+          if ( uiNoResidual == 0 && rpcTempCU->getQtRootCbf(0) == 0 )
           {
-#endif
-            rpcTempCU->setInterDirSubParts( uhInterDirNeighbours[uiMergeCand], 0, 0, uhDepth ); // interprets depth relative to LCU level
-            rpcTempCU->getCUMvField( REF_PIC_LIST_0 )->setAllMvField( cMvFieldNeighbours[0 + 2*uiMergeCand], SIZE_2Nx2N, 0, 0 ); // interprets depth relative to rpcTempCU level
-            rpcTempCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMvFieldNeighbours[1 + 2*uiMergeCand], SIZE_2Nx2N, 0, 0 ); // interprets depth relative to rpcTempCU level
-#if H_3D_VSP
+            // If no residual when allowing for one, then set mark to not try case where residual is forced to 0
+            mergeCandBuffer[uiMergeCand] = 1;
           }
-        }
-#endif
-       // do MC
-       m_pcPredSearch->motionCompensation ( rpcTempCU, m_ppcPredYuvTemp[uhDepth] );
-       // estimate residual and encode everything
-#if H_3D_VSO //M2
-       if( m_pcRdCost->getUseRenModel() )
-       { //Reset
-         UInt  uiWidth     = m_ppcOrigYuv[uhDepth]->getWidth    ();
-         UInt  uiHeight    = m_ppcOrigYuv[uhDepth]->getHeight   ();
-         Pel*  piSrc       = m_ppcOrigYuv[uhDepth]->getLumaAddr ();
-         UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride   ();
-         m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-       }
-#endif
-       m_pcPredSearch->encodeResAndCalcRdInterCU( rpcTempCU,
-         m_ppcOrigYuv    [uhDepth],
-         m_ppcPredYuvTemp[uhDepth],
-         m_ppcResiYuvTemp[uhDepth],
-         m_ppcResiYuvBest[uhDepth],
-         m_ppcRecoYuvTemp[uhDepth],
-         (uiNoResidual? true:false));
-
-
-          if ( uiNoResidual == 0 && rpcTempCU->getQtRootCbf(0) == 0 )
-         {
-            // If no residual when allowing for one, then set mark to not try case where residual is forced to 0
-           mergeCandBuffer[uiMergeCand] = 1;
-         }
 
           rpcTempCU->setSkipFlagSubParts( rpcTempCU->getQtRootCbf(0) == 0, 0, uhDepth );
@@ -2094,53 +2100,53 @@
           rpcTempCU->initEstData( uhDepth, orgQP, bTransquantBypassFlag );
 
-      if( m_pcEncCfg->getUseFastDecisionForMerge() && !bestIsSkip )
+          if( m_pcEncCfg->getUseFastDecisionForMerge() && !bestIsSkip )
+          {
+#if H_3D_INTER_SDC
+            if( rpcTempCU->getSlice()->getInterSdcFlag() )
+            {
+              bestIsSkip = !rpcBestCU->getSDCFlag( 0 ) && ( rpcBestCU->getQtRootCbf(0) == 0 );
+            }
+            else
+            {
+#endif
+              bestIsSkip = rpcBestCU->getQtRootCbf(0) == 0;
+#if H_3D_INTER_SDC
+            }
+#endif
+          }
+        }
+      }
+    }
+
+    if(uiNoResidual == 0 && m_pcEncCfg->getUseEarlySkipDetection())
+    {
+      if(rpcBestCU->getQtRootCbf( 0 ) == 0)
       {
-#if H_3D_INTER_SDC
-        if( rpcTempCU->getSlice()->getInterSdcFlag() )
+        if( rpcBestCU->getMergeFlag( 0 ))
         {
-          bestIsSkip = !rpcBestCU->getSDCFlag( 0 ) && ( rpcBestCU->getQtRootCbf(0) == 0 );
+          *earlyDetectionSkipMode = true;
         }
         else
         {
-#endif
-        bestIsSkip = rpcBestCU->getQtRootCbf(0) == 0;
-#if H_3D_INTER_SDC
-        }
-#endif
-      }
-    }
-   }
-  }
-
-  if(uiNoResidual == 0 && m_pcEncCfg->getUseEarlySkipDetection())
-  {
-    if(rpcBestCU->getQtRootCbf( 0 ) == 0)
-    {
-      if( rpcBestCU->getMergeFlag( 0 ))
-      {
-        *earlyDetectionSkipMode = true;
-      }
-      else
-      {
-        Int absoulte_MV=0;
-        for ( UInt uiRefListIdx = 0; uiRefListIdx < 2; uiRefListIdx++ )
-        {
-          if ( rpcBestCU->getSlice()->getNumRefIdx( RefPicList( uiRefListIdx ) ) > 0 )
+          Int absoulte_MV=0;
+          for ( UInt uiRefListIdx = 0; uiRefListIdx < 2; uiRefListIdx++ )
           {
-            TComCUMvField* pcCUMvField = rpcBestCU->getCUMvField(RefPicList( uiRefListIdx ));
-            Int iHor = pcCUMvField->getMvd( 0 ).getAbsHor();
-            Int iVer = pcCUMvField->getMvd( 0 ).getAbsVer();
-            absoulte_MV+=iHor+iVer;
+            if ( rpcBestCU->getSlice()->getNumRefIdx( RefPicList( uiRefListIdx ) ) > 0 )
+            {
+              TComCUMvField* pcCUMvField = rpcBestCU->getCUMvField(RefPicList( uiRefListIdx ));
+              Int iHor = pcCUMvField->getMvd( 0 ).getAbsHor();
+              Int iVer = pcCUMvField->getMvd( 0 ).getAbsVer();
+              absoulte_MV+=iHor+iVer;
+            }
+          }
+
+          if(absoulte_MV == 0)
+          {
+            *earlyDetectionSkipMode = true;
           }
         }
-
-        if(absoulte_MV == 0)
-        {
-          *earlyDetectionSkipMode = true;
-        }
       }
     }
   }
- }
 #if H_3D_SPIVMP
  delete[] pcMvFieldSP;
@@ -2163,5 +2169,4 @@
 #endif
 {
-
 #if H_3D
   const Bool bTransquantBypassFlag = rpcTempCU->getCUTransquantBypass(0);
@@ -2171,149 +2176,20 @@
   {
 #endif
-  UChar uhDepth = rpcTempCU->getDepth( 0 );
+    UChar uhDepth = rpcTempCU->getDepth( 0 );
 #if H_3D_ARP
-  Bool bFirstTime = true;
-  Int nARPWMax    = rpcTempCU->getSlice()->getARPStepNum() - 1;
-  if( nARPWMax < 0 || ePartSize != SIZE_2Nx2N || rpcTempCU->getICFlag(0) )
-  {
-    nARPWMax = 0;
-  }
-
-  for( Int nARPW = 0; nARPW <= nARPWMax; nARPW++ )
-  {
-    if( !bFirstTime && rpcTempCU->getSlice()->getIvResPredFlag() )
-    {
-      rpcTempCU->initEstData( rpcTempCU->getDepth(0), rpcTempCU->getQP(0),bTransquantBypassFlag );      
-    }
-#endif
-#if H_3D_VSO // M3
-  if( m_pcRdCost->getUseRenModel() )
-  {
-    UInt  uiWidth     = m_ppcOrigYuv[uhDepth]->getWidth ( );
-    UInt  uiHeight    = m_ppcOrigYuv[uhDepth]->getHeight( );
-    Pel*  piSrc       = m_ppcOrigYuv[uhDepth]->getLumaAddr( );
-    UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride();
-    m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-  }
-#endif
-
-  rpcTempCU->setDepthSubParts( uhDepth, 0 );
-  
-  rpcTempCU->setSkipFlagSubParts( false, 0, uhDepth );
-#if H_3D
-  rpcTempCU->setDISFlagSubParts( false, 0, uhDepth );
-#endif
-  rpcTempCU->setPartSizeSubParts  ( ePartSize,  0, uhDepth );
-  rpcTempCU->setPredModeSubParts  ( MODE_INTER, 0, uhDepth );
-
-#if H_3D_ARP
-  rpcTempCU->setARPWSubParts( (UChar)nARPW , 0 , uhDepth );
-#endif
-
-#if H_3D_ARP
-  if( bFirstTime == false && nARPWMax )
-  {
-    rpcTempCU->copyPartFrom( m_ppcWeightedTempCU[uhDepth] , 0 , uhDepth );
-    rpcTempCU->setARPWSubParts( (UChar)nARPW , 0 , uhDepth );
-
-    m_pcPredSearch->motionCompensation( rpcTempCU , m_ppcPredYuvTemp[uhDepth] );
-  }
-  else
-  {
-    bFirstTime = false;
-#endif
-#if AMP_MRG
-  rpcTempCU->setMergeAMP (true);
-#if  H_3D_FAST_TEXTURE_ENCODING
-  m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth], bFMD, false, bUseMRG );
-#else
-  m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth], false, bUseMRG );
-#endif
-#else  
-  m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth] );
-#endif
-#if H_3D_ARP
-   if( nARPWMax )
-   {
-     m_ppcWeightedTempCU[uhDepth]->copyPartFrom( rpcTempCU , 0 , uhDepth );
-   }
-  }
-#endif
-
-#if AMP_MRG
-  if ( !rpcTempCU->getMergeAMP() )
-  {
-#if H_3D_ARP
-    if( nARPWMax )
-    {
-      continue;
-    }
-    else
-#endif
-    return;
-  }
-#endif
-
-#if KWU_RC_MADPRED_E0227
-  if ( m_pcEncCfg->getUseRateCtrl() && m_pcEncCfg->getLCULevelRC() && ePartSize == SIZE_2Nx2N && uhDepth <= m_addSADDepth )
-  {
-    UInt SAD = m_pcRdCost->getSADPart( g_bitDepthY, m_ppcPredYuvTemp[uhDepth]->getLumaAddr(), m_ppcPredYuvTemp[uhDepth]->getStride(),
-      m_ppcOrigYuv[uhDepth]->getLumaAddr(), m_ppcOrigYuv[uhDepth]->getStride(),
-      rpcTempCU->getWidth(0), rpcTempCU->getHeight(0) );
-    m_temporalSAD = (Int)SAD;
-  }
-#endif
-  m_pcPredSearch->encodeResAndCalcRdInterCU( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcResiYuvBest[uhDepth], m_ppcRecoYuvTemp[uhDepth], false );
-#if H_3D_VSP // possible bug fix
-  if( rpcTempCU->getQtRootCbf(0)==0 )
-  {
-    rpcTempCU->setTrIdxSubParts(0, 0, uhDepth);
-  }
-#endif
-#if H_3D_VSO // M4
-  if( m_pcRdCost->getUseLambdaScaleVSO() )
-    rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCostVSO( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
-  else
-#endif
-  rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
-#if H_3D_INTER_SDC
-  TComDataCU *rpcTempCUPre = rpcTempCU;
-#endif
-  xCheckDQP( rpcTempCU );
-  xCheckBestMode(rpcBestCU, rpcTempCU, uhDepth);
-#if H_3D_INTER_SDC
-  if( rpcTempCU->getSlice()->getInterSdcFlag() && ePartSize == SIZE_2Nx2N)
-  {
-    Double dOffsetCost[3] = {MAX_DOUBLE,MAX_DOUBLE,MAX_DOUBLE};
-    for( Int uiOffest = 1 ; uiOffest <= 5 ; uiOffest++ )
-    {
-      if( uiOffest > 3)
+    Bool bFirstTime = true;
+    Int nARPWMax    = rpcTempCU->getSlice()->getARPStepNum() - 1;
+    if( nARPWMax < 0 || ePartSize != SIZE_2Nx2N || rpcTempCU->getICFlag(0) )
+    {
+      nARPWMax = 0;
+    }
+
+    for( Int nARPW = 0; nARPW <= nARPWMax; nARPW++ )
+    {
+      if( !bFirstTime && rpcTempCU->getSlice()->getIvResPredFlag() )
       {
-        if ( dOffsetCost[0] < (0.9*dOffsetCost[1]) && dOffsetCost[0] < (0.9*dOffsetCost[2]) )
-        {
-          continue;
-        }
-        if ( dOffsetCost[1] < dOffsetCost[0] && dOffsetCost[0] < dOffsetCost[2] &&  uiOffest == 5)
-        {
-          continue;
-        }
-        if ( dOffsetCost[0] < dOffsetCost[1] && dOffsetCost[2] < dOffsetCost[0] &&  uiOffest == 4)
-        {
-          continue;
-        }
+        rpcTempCU->initEstData( rpcTempCU->getDepth(0), rpcTempCU->getQP(0),bTransquantBypassFlag );      
       }
-
-      if( rpcTempCU != rpcTempCUPre )
-      {
-        Int orgQP = rpcBestCU->getQP( 0 );
-        rpcTempCU->initEstData( uhDepth, orgQP ,bTransquantBypassFlag );      
-        rpcTempCU->copyPartFrom( rpcBestCU, 0, uhDepth );
-      }
-      rpcTempCU->setSkipFlagSubParts( false, 0, uhDepth );
-#if H_3D
-      rpcTempCU->setDISFlagSubParts( false, 0, uhDepth );
-#endif
-      rpcTempCU->setTrIdxSubParts( 0, 0, uhDepth );
-      rpcTempCU->setCbfSubParts( 1, 1, 1, 0, uhDepth );
+#endif
 #if H_3D_VSO // M3
       if( m_pcRdCost->getUseRenModel() )
@@ -2327,33 +2203,160 @@
 #endif
 
-      Int iSdcOffset = 0;
-      if(uiOffest % 2 == 0)
+      rpcTempCU->setDepthSubParts( uhDepth, 0 );
+
+      rpcTempCU->setSkipFlagSubParts( false, 0, uhDepth );
+#if H_3D
+      rpcTempCU->setDISFlagSubParts( false, 0, uhDepth );
+#endif
+      rpcTempCU->setPartSizeSubParts  ( ePartSize,  0, uhDepth );
+      rpcTempCU->setPredModeSubParts  ( MODE_INTER, 0, uhDepth );
+#if H_3D_ARP
+      rpcTempCU->setARPWSubParts( (UChar)nARPW , 0 , uhDepth );
+#endif
+#if H_3D_ARP
+      if( bFirstTime == false && nARPWMax )
       {
-        iSdcOffset = uiOffest >> 1;
+        rpcTempCU->copyPartFrom( m_ppcWeightedTempCU[uhDepth] , 0 , uhDepth );
+        rpcTempCU->setARPWSubParts( (UChar)nARPW , 0 , uhDepth );
+
+        m_pcPredSearch->motionCompensation( rpcTempCU , m_ppcPredYuvTemp[uhDepth] );
       }
       else
       {
-        iSdcOffset = -1 * (uiOffest >> 1);
+        bFirstTime = false;
+#endif
+#if AMP_MRG
+        rpcTempCU->setMergeAMP (true);
+#if  H_3D_FAST_TEXTURE_ENCODING
+        m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth], bFMD, false, bUseMRG );
+#else
+        m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth], false, bUseMRG );
+#endif
+#else  
+        m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth] );
+#endif
+#if H_3D_ARP
+        if( nARPWMax )
+        {
+          m_ppcWeightedTempCU[uhDepth]->copyPartFrom( rpcTempCU , 0 , uhDepth );
+        }
       }
-      m_pcPredSearch->encodeResAndCalcRdInterSDCCU( rpcTempCU, 
-        m_ppcOrigYuv[uhDepth],
-        ( rpcTempCU != rpcTempCUPre ) ? m_ppcPredYuvBest[uhDepth] : m_ppcPredYuvTemp[uhDepth],
-        m_ppcResiYuvTemp[uhDepth],
-        m_ppcRecoYuvTemp[uhDepth],
-        iSdcOffset,
-        uhDepth );
-      if (uiOffest <= 3 )
+#endif
+
+#if AMP_MRG
+      if ( !rpcTempCU->getMergeAMP() )
       {
-        dOffsetCost [uiOffest -1] = rpcTempCU->getTotalCost();
+#if H_3D_ARP
+        if( nARPWMax )
+        {
+          continue;
+        }
+        else
+#endif
+          return;
       }
-
+#endif
+
+#if KWU_RC_MADPRED_E0227
+      if ( m_pcEncCfg->getUseRateCtrl() && m_pcEncCfg->getLCULevelRC() && ePartSize == SIZE_2Nx2N && uhDepth <= m_addSADDepth )
+      {
+        UInt SAD = m_pcRdCost->getSADPart( g_bitDepthY, m_ppcPredYuvTemp[uhDepth]->getLumaAddr(), m_ppcPredYuvTemp[uhDepth]->getStride(),
+          m_ppcOrigYuv[uhDepth]->getLumaAddr(), m_ppcOrigYuv[uhDepth]->getStride(),
+          rpcTempCU->getWidth(0), rpcTempCU->getHeight(0) );
+        m_temporalSAD = (Int)SAD;
+      }
+#endif
+      m_pcPredSearch->encodeResAndCalcRdInterCU( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcResiYuvBest[uhDepth], m_ppcRecoYuvTemp[uhDepth], false );
+#if H_3D_VSP // possible bug fix
+      if( rpcTempCU->getQtRootCbf(0)==0 )
+      {
+        rpcTempCU->setTrIdxSubParts(0, 0, uhDepth);
+      }
+#endif
+#if H_3D_VSO // M4
+      if( m_pcRdCost->getUseLambdaScaleVSO() )
+        rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCostVSO( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
+      else
+#endif
+        rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
+#if H_3D_INTER_SDC
+      TComDataCU *rpcTempCUPre = rpcTempCU;
+#endif
       xCheckDQP( rpcTempCU );
       xCheckBestMode(rpcBestCU, rpcTempCU, uhDepth);
-    }
-
-  }
+#if H_3D_INTER_SDC
+      if( rpcTempCU->getSlice()->getInterSdcFlag() && ePartSize == SIZE_2Nx2N)
+      {
+        Double dOffsetCost[3] = {MAX_DOUBLE,MAX_DOUBLE,MAX_DOUBLE};
+        for( Int uiOffest = 1 ; uiOffest <= 5 ; uiOffest++ )
+        {
+          if( uiOffest > 3)
+          {
+            if ( dOffsetCost[0] < (0.9*dOffsetCost[1]) && dOffsetCost[0] < (0.9*dOffsetCost[2]) )
+            {
+              continue;
+            }
+            if ( dOffsetCost[1] < dOffsetCost[0] && dOffsetCost[0] < dOffsetCost[2] &&  uiOffest == 5)
+            {
+              continue;
+            }
+            if ( dOffsetCost[0] < dOffsetCost[1] && dOffsetCost[2] < dOffsetCost[0] &&  uiOffest == 4)
+            {
+              continue;
+            }
+          }
+
+          if( rpcTempCU != rpcTempCUPre )
+          {
+            Int orgQP = rpcBestCU->getQP( 0 );
+            rpcTempCU->initEstData( uhDepth, orgQP ,bTransquantBypassFlag );      
+            rpcTempCU->copyPartFrom( rpcBestCU, 0, uhDepth );
+          }
+          rpcTempCU->setSkipFlagSubParts( false, 0, uhDepth );
+#if H_3D
+          rpcTempCU->setDISFlagSubParts( false, 0, uhDepth );
+#endif
+          rpcTempCU->setTrIdxSubParts( 0, 0, uhDepth );
+          rpcTempCU->setCbfSubParts( 1, 1, 1, 0, uhDepth );
+#if H_3D_VSO // M3
+          if( m_pcRdCost->getUseRenModel() )
+          {
+            UInt  uiWidth     = m_ppcOrigYuv[uhDepth]->getWidth ( );
+            UInt  uiHeight    = m_ppcOrigYuv[uhDepth]->getHeight( );
+            Pel*  piSrc       = m_ppcOrigYuv[uhDepth]->getLumaAddr( );
+            UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride();
+            m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
+          }
+#endif
+
+          Int iSdcOffset = 0;
+          if(uiOffest % 2 == 0)
+          {
+            iSdcOffset = uiOffest >> 1;
+          }
+          else
+          {
+            iSdcOffset = -1 * (uiOffest >> 1);
+          }
+          m_pcPredSearch->encodeResAndCalcRdInterSDCCU( rpcTempCU, 
+            m_ppcOrigYuv[uhDepth],
+            ( rpcTempCU != rpcTempCUPre ) ? m_ppcPredYuvBest[uhDepth] : m_ppcPredYuvTemp[uhDepth],
+            m_ppcResiYuvTemp[uhDepth],
+            m_ppcRecoYuvTemp[uhDepth],
+            iSdcOffset,
+            uhDepth );
+          if (uiOffest <= 3 )
+          {
+            dOffsetCost [uiOffest -1] = rpcTempCU->getTotalCost();
+          }
+
+          xCheckDQP( rpcTempCU );
+          xCheckBestMode(rpcBestCU, rpcTempCU, uhDepth);
+        }
+
+      }
 #endif
 #if H_3D_ARP
-  }
+    }
 #endif
 #if  H_3D_FAST_TEXTURE_ENCODING
@@ -2548,5 +2551,5 @@
   // find optimal motion/disparity vector for each segment
   DisInfo originalDvInfo = rpcTempCU->getDvInfo(0);
-  DBBPTmpData* pDBBPTmpData = rpcTempCU->getDBBPTmpData();
+  DbbpTmpData* pDBBPTmpData = rpcTempCU->getDBBPTmpData();
   TComYuv* apPredYuv[2] = { m_ppcRecoYuvTemp[uhDepth], m_ppcPredYuvTemp[uhDepth] };
   
@@ -2629,4 +2632,5 @@
 }
 #endif
+
 #if H_3D_DIM
 Void TEncCu::xCheckRDCostIntra( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize eSize, Bool bOnlyIVP )
@@ -2670,5 +2674,5 @@
   if( !rpcTempCU->getSDCFlag( 0 ) )
 #endif
-  m_pcPredSearch  ->estIntraPredChromaQT( rpcTempCU, m_ppcOrigYuv[uiDepth], m_ppcPredYuvTemp[uiDepth], m_ppcResiYuvTemp[uiDepth], m_ppcRecoYuvTemp[uiDepth], uiPreCalcDistC );
+    m_pcPredSearch  ->estIntraPredChromaQT( rpcTempCU, m_ppcOrigYuv[uiDepth], m_ppcPredYuvTemp[uiDepth], m_ppcResiYuvTemp[uiDepth], m_ppcRecoYuvTemp[uiDepth], uiPreCalcDistC );
   
   m_pcEntropyCoder->resetBits();
@@ -2683,22 +2687,20 @@
   {
 #endif
-  m_pcEntropyCoder->encodePredMode( rpcTempCU, 0,          true );
-  m_pcEntropyCoder->encodePartSize( rpcTempCU, 0, uiDepth, true );
-  m_pcEntropyCoder->encodePredInfo( rpcTempCU, 0,          true );
-  m_pcEntropyCoder->encodeIPCMInfo(rpcTempCU, 0, true );
+    m_pcEntropyCoder->encodePredMode( rpcTempCU, 0,          true );
+    m_pcEntropyCoder->encodePartSize( rpcTempCU, 0, uiDepth, true );
+    m_pcEntropyCoder->encodePredInfo( rpcTempCU, 0,          true );
+    m_pcEntropyCoder->encodeIPCMInfo(rpcTempCU, 0, true );
 #if H_3D_DIM_SDC
-  m_pcEntropyCoder->encodeSDCFlag( rpcTempCU, 0, true );
-#endif
-
-  // Encode Coefficients
-  Bool bCodeDQP = getdQPFlag();
+    m_pcEntropyCoder->encodeSDCFlag( rpcTempCU, 0, true );
+#endif
+
+    // Encode Coefficients
+    Bool bCodeDQP = getdQPFlag();
 #if H_3D_DISABLE_CHROMA
-  m_pcEntropyCoder->encodeCoeff( rpcTempCU, 0, uiDepth, rpcTempCU->getWidth (0), rpcTempCU->getHeight(0), bCodeDQP, true );
-#else
-  m_pcEntropyCoder->encodeCoeff( rpcTempCU, 0, uiDepth, rpcTempCU->getWidth (0), rpcTempCU->getHeight(0), bCodeDQP );
-#endif
-
-
-  setdQPFlag( bCodeDQP );
+    m_pcEntropyCoder->encodeCoeff( rpcTempCU, 0, uiDepth, rpcTempCU->getWidth (0), rpcTempCU->getHeight(0), bCodeDQP, true );
+#else
+    m_pcEntropyCoder->encodeCoeff( rpcTempCU, 0, uiDepth, rpcTempCU->getWidth (0), rpcTempCU->getHeight(0), bCodeDQP );
+#endif
+    setdQPFlag( bCodeDQP );
 #if H_3D
   }
@@ -2707,5 +2709,5 @@
   
   rpcTempCU->getTotalBits() = m_pcEntropyCoder->getNumberOfWrittenBits();
-    rpcTempCU->getTotalBins() = ((TEncBinCABAC *)((TEncSbac*)m_pcEntropyCoder->m_pcEntropyCoderIf)->getEncBinIf())->getBinsCoded();
+  rpcTempCU->getTotalBins() = ((TEncBinCABAC *)((TEncSbac*)m_pcEntropyCoder->m_pcEntropyCoderIf)->getEncBinIf())->getBinsCoded();
 #if H_3D_VSO // M6
   if( m_pcRdCost->getUseLambdaScaleVSO())  
